//=============================================================================
//
//  CLASS Ray - IMPLEMENTATION
//
//=============================================================================
#define RAYTRACER_RAY_CPP

//== INCLUDES =================================================================
#include "Ray.h"

//== IMPLEMENTATION ===========================================================
Ray Ray::reflectedRay(
    const VectorType3   &v3Point,
    const VectorType3   &v3Normal )  const
{
    /*
		Implement the computation of the ray reflected at the point v3Point with the normal v3Normal.
		
		reflection_direction = incoming_dir - 2*(normalincoming_dir)*normal
    */
    Ray result; 
    return result;
};

//-----------------------------------------------------------------------------
bool Ray::refractedRay(
    const VectorType3   &v3Point,
    const VectorType3   &v3Normal,
    double            rRefractiveIndex,
    Ray                 &clRefractedRay )  const
{

    /*
		Implement the computation of the refracted ray at the point v3Point with 
		the normal v3Normal and the refractive index rRefractiveIndex. If a 
		total reflection happens, return false.
		
		Hint: You can assume, that the transition always happens between the material 
		with refractive index rRefractiveIndex and air (refractive index ~1).
		
        cosTheta = - incoming_dir * normal
    */

    return true;
};